#include <stdio.h>
#include <stdlib.h>

  /* Kopiranje datoteke, znak po znak.
     Koristi funkciju za kopiranje. */

void copy_file(FILE *in, FILE *out)
{
    int c;    /* Ne: char c! */

    while ((c = fgetc(in)) != EOF)
        fputc(c, out);

    return;
}

    /* Glavni program. */

int main(int argc, char *argv[])
{
    FILE *in, *out;

    if (argc != 3) {    /* Nema imena datoteka! */
        fprintf(stderr, "Uporaba: %s ime1 ime2\n",
                argv[0]);
        exit(1);
    }

    if ((in = fopen(argv[1], "r")) == NULL) {
        fprintf(stderr, "Ne mogu citati: %s!\n",
                argv[1]);
        exit(2);
    }

    if ((out = fopen(argv[2], "w")) == NULL) {
        fprintf(stderr, "Ne mogu pisati: %s!\n",
                argv[2]);
        exit(3);
    }

    copy_file(in, out);

    fclose(in);
    fclose(out);

    return 0;
}
